VERSION 5.00
Begin VB.UserControl ucMap 
   ClientHeight    =   3000
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   7245
   EditAtDesignTime=   -1  'True
   ScaleHeight     =   200
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   483
   Begin VB.PictureBox Picture1 
      BorderStyle     =   0  'None
      Height          =   375
      Left            =   0
      ScaleHeight     =   375
      ScaleWidth      =   735
      TabIndex        =   0
      Top             =   0
      Width           =   735
   End
   Begin VB.Timer Timer1 
      Left            =   1800
      Top             =   1320
   End
End
Attribute VB_Name = "ucMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Declare Function GetSysColor Lib "user32.dll" (ByVal nIndex As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hDC As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function SetParent Lib "user32.dll" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Private Declare Function GetDesktopWindow Lib "user32.dll" () As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function SetWindowPos Lib "user32.dll" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal CX As Long, ByVal CY As Long, ByVal wFlags As Long) As Long
Private Declare Function EnableWindow Lib "user32.dll" (ByVal hwnd As Long, ByVal fEnable As Long) As Long
Private Declare Function LoadLibraryW Lib "KERNEL32" (ByVal lpLibFileName As Long) As Long
Private Declare Function GetInstanceEx Lib "DirectCOM" (spFName As Long, spClassName As Long, Optional ByVal UseAlteredSearchPath As Boolean = True) As Object

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private WithEvents WV As cWebView2 'declare a WebView-variable WithEvents
Attribute WV.VB_VarHelpID = -1

Public Enum eMapType
    MT_ROADMAP
    MT_HYBRID
    MT_SATELLITE
End Enum

Public Enum eAnimation
    A_NONE
    A_DROP
    A_BOUNCE
    A_BOUNCEUP
    A_BOUNCEDOWN
End Enum

Private Type position
    Lat As Single
    Lng As Single
End Type

Private Const DirectComDllRelPath = "\Bin\DirectCOM.dll"
Private Const RCDllRelPath = "\Bin\RC6.dll"

Private Const MARKER_EVENTS = "click,dblclick,rightclick,dragstart,drag,dragend,mouseover,mouseout"
Private Const MAP_EVENTS = "bounds_changed,center_changed,click,contextmenu,dblclick,drag,dragend,dragstart,heading_changed,idle,maptypeid_changed,mousemove,mouseout,mouseover,projection_changed,resize,rightclick,tilesloaded,tilt_changed,zoom_changed"
Private Const DEFAULT_API_KEY = "AIzaSyBt8Flu0XobmWESP01JdfYaJM8jaibN2hc"

Public Event DirectionsChanged(cRoute As ClsRoute)
Public Event GeolocationResult(ByVal Lat As String, ByVal Lng As String)
Public Event MapClick(ByVal Lat As String, ByVal Lng As String)
Public Event MapMouseMove(ByVal Lat As String, ByVal Lng As String)
Public Event MarkerEvents(ByVal EventName As String, ItemData As String)
Public Event SelectionEvents(ByVal EventName As String, ByVal North, ByVal South, ByVal East, ByVal West)
Public Event LoadComplete()


Private m_DisableDefaultUI As Boolean
Private m_Zoom As Integer
Private m_MapTypeId As eMapType
Private m_MapCenter As position
Private objScript As Object
Private m_mapTypeControl As Boolean
Private m_fullscreenControl As Boolean
Private m_streetViewControl As Boolean
Private m_zoomControl As Boolean
Private m_BorderWidth As Long
Private m_BorderRadius As Long
Private m_BorderColor As Long
Private DpiF As Single

Private m_ShadowSize As Long
Private m_ShadowColor As OLE_COLOR
Private m_ShadowOpacity As OLE_COLOR
Private m_ShadowOffsetX As Long
Private m_ShadowOffsetY As Long
Private m_Enabled As Boolean
Private m_ApiKey As String
Private m_Chrome_WidgetWin_0 As Long
Private bEditMode As Boolean

Private Property Get New_c() As cConstructor
  Static st_RC As cConstructor
  If Not st_RC Is Nothing Then Set New_c = st_RC: Exit Property
  
  If App.LogMode Then  'we run compiled - and try to ensure regfree instantiation from \Bin\
     On Error Resume Next
        LoadLibraryW StrPtr(App.Path & DirectComDllRelPath)
        Set st_RC = GetInstanceEx(StrPtr(App.Path & RCDllRelPath), StrPtr("cConstructor"))
        If st_RC Is Nothing Then MsgBox "Couldn't load regfree, will try with a registered version next..."
     On Error GoTo 0
  End If
  If st_RC Is Nothing Then Set st_RC = cGlobal.New_c 'fall back to loading a registered version
  Set New_c = st_RC
End Property

Private Property Get Cairo() As cCairo
  Static st_CR As cCairo
  If st_CR Is Nothing Then Set st_CR = New_c.Cairo
  Set Cairo = st_CR
End Property


Private Sub WV_AcceleratorKeyPressed(ByVal KeyState As RC6.eWebView2AccKeyState, ByVal IsExtendedKey As Boolean, ByVal WasKeyDown As Boolean, ByVal IsKeyReleased As Boolean, ByVal IsMenuKeyDown As Boolean, ByVal RepeatCount As Long, ByVal ScanCode As Long, IsHandled As Boolean)
    'Debug.Print ScanCode
    
    If ScanCode > 58 And ScanCode < 68 Or ScanCode > 86 And ScanCode < 89 Then
        IsHandled = True
    End If
End Sub


Public Function InitStreetViewPanorama(ByVal Lat As String, ByVal Lng As String, Optional ByVal Heading As Integer, Optional ByVal Pitch As Integer)
    Dim sJS As String

    sJS = "var latlng = new google.maps.LatLng(" & sSng(Lat) & "," & sSng(Lng) & ");"
    sJS = sJS & "var panorama = new google.maps.StreetViewPanorama("
    sJS = sJS & "document.getElementById('map_canvas'),"
    sJS = sJS & "{position:latlng,pov:{heading:" & Heading & ",pitch:" & Pitch & ",},}"
    sJS = sJS & ");"
    
    Call WV.ExecuteScript(sJS)
End Function

Public Function GroundOverlays(ImgUrl As String, North, South, East, West, Optional Opacity = 1)
    Dim sJS As String
    sJS = sJS & " var imageBounds = {"
    sJS = sJS & "    north: " & sSng(North) & ", "
    sJS = sJS & "    south: " & sSng(South) & ", "
    sJS = sJS & "    east: " & sSng(East) & ", "
    sJS = sJS & "    west: " & sSng(West) & ", "
    sJS = sJS & "  };"
    sJS = sJS & "  var ImgOverlay = new google.maps.GroundOverlay('" & ImgUrl & "',imageBounds);"
    sJS = sJS & "  ImgOverlay.setOpacity(" & sSng(Opacity) & ");"
    sJS = sJS & "  ImgOverlay.setMap(map);"

    Call WV.ExecuteScript(sJS)
End Function


Public Function AddRectSelection(North, South, East, West)
    Dim sJS As String
    sJS = sJS & " var bounds = {"
    sJS = sJS & "    north: " & sSng(North) & ", "
    sJS = sJS & "    south: " & sSng(South) & ", "
    sJS = sJS & "    east: " & sSng(East) & ", "
    sJS = sJS & "    west: " & sSng(West) & ", "
    sJS = sJS & "   };"
    '  // Define a rectangle and set its editable property to true.
    sJS = sJS & "   var rectangle = new google.maps.Rectangle({"
    sJS = sJS & "     bounds: bounds,"
    sJS = sJS & "     editable: true,"
    sJS = sJS & "     draggable: true,"
    sJS = sJS & "   });"
    
    sJS = sJS & "   rectangle.setMap(map);"
    '  // listen to changes
    sJS = sJS & "   ['bounds_changed', 'dragstart', 'drag', 'dragend'].forEach((eventName) => {"
    sJS = sJS & "     rectangle.addListener(eventName, () => {"
    '      console.log({ bounds: rectangle.getBounds()?.toJSON(), eventName });
    sJS = sJS & "   vbH().RaiseMessageEvent('Selection_' + eventName ,rectangle.getBounds()?.toString());"
    sJS = sJS & "    });"
    sJS = sJS & "  });"


    Call WV.ExecuteScript(sJS)
End Function

Public Sub getSelection(North, South, West, East)
          Dim sBounds As String
          Dim sParams() As String
          sBounds = WV.jsProp("rectangle.getBounds()?.toString()")
          sBounds = Replace$(sBounds, "(", "")
          sBounds = Replace$(sBounds, ")", "")
          sParams = Split(sBounds, ",")
          North = sParams(2)
          South = sParams(0)
          West = sParams(3)
          East = sParams(1)
End Sub

Public Sub RemoveGroundOverlays()
    Call WV.ExecuteScript("ImgOverlay.setMap(null);")
End Sub

Public Sub Geolocation()
    Dim sJS As String

    sJS = sJS & "if (navigator.geolocation) {"
    sJS = sJS & "  navigator.geolocation.getCurrentPosition(function(position) {"
    sJS = sJS & "    var lat = position.coords.latitude;"
    sJS = sJS & "    var lng = position.coords.longitude;"
    sJS = sJS & "    vbH().RaiseMessageEvent('GeolocationsResult',lat +','+lng);"
    sJS = sJS & "  });"
    sJS = sJS & "} else {"
    sJS = sJS & "  alert('La geolocalizacin no est soportada en este navegador.');"
    sJS = sJS & "}"
   
    Call WV.ExecuteScript(sJS)
End Sub

Public Function GeocodeLatLng(Lat, Lng) As String
    Dim xmlDoc As Object
    Set xmlDoc = CreateObject("MSXML2.DOMDocument")
    xmlDoc.async = False
    xmlDoc.Load "https://maps.googleapis.com/maps/api/geocode/xml?latlng=" & sSng(Lat) & "," & sSng(Lng) & "&key=" & m_ApiKey
    
    If xmlDoc.GetElementsByTagName("status").Item(0).Text = "OK" Then
        GeocodeLatLng = xmlDoc.GetElementsByTagName("formatted_address").Item(0).Text
    End If

End Function

Public Function GetDistance(ByVal Origins As String, ByVal Destinations As String) As String
    Dim xmlDoc As Object
    Set xmlDoc = CreateObject("MSXML2.DOMDocument")
    xmlDoc.async = False
    xmlDoc.Load "https://maps.googleapis.com/maps/api/distancematrix/xml?origins=" & Origins & "&destinations=" & Destinations & "&key=" & m_ApiKey
    
    
    If xmlDoc.GetElementsByTagName("status").Item(0).Text = "OK" Then
        GetDistance = xmlDoc.GetElementsByTagName("distance/value").Item(0).Text
    End If

End Function

Public Function GetAutocomplete(ByVal sInput As String) As Object
    Dim xmlDoc As Object
    Dim sUrl As String
    sUrl = "https://maps.googleapis.com/maps/api/place/autocomplete/xml?input=" & URLdecshort(sInput) & "&language=es&key=" & m_ApiKey
    'sUrl = sUrl & "&types=address"

    Set xmlDoc = CreateObject("MSXML2.DOMDocument")
    xmlDoc.async = False
    xmlDoc.Load sUrl

    Set GetAutocomplete = xmlDoc
End Function

Public Function URLdecshort(ByRef Text As String) As String
    Dim strArray() As String, lngA As Long
    strArray = Split(Replace(Text, "+", " "), "%")
    For lngA = 1 To UBound(strArray)
        strArray(lngA) = Chr$("&H" & Left$(strArray(lngA), 2)) & Mid$(strArray(lngA), 3)
    Next lngA
    URLdecshort = Join(strArray, vbNullString)
End Function

Public Function GetLocationElevation(ByVal Lat As String, ByVal Lng As String) As String
    Dim xmlDoc As Object
    Set xmlDoc = CreateObject("MSXML2.DOMDocument")
    xmlDoc.async = False
    xmlDoc.Load "https://maps.googleapis.com/maps/api/elevation/xml?locations=" & sSng(Lat) & "," & sSng(Lng) & "&key=" & m_ApiKey

    If xmlDoc.GetElementsByTagName("status").Item(0).Text = "OK" Then
        GetLocationElevation = xmlDoc.GetElementsByTagName("elevation").Item(0).Text
    End If

End Function

Public Function GetLocationsElevation(Points) As Collection
    Dim xmlDoc As Object
    Dim i As Long
    Set xmlDoc = CreateObject("MSXML2.DOMDocument")
    Dim sParam As String
    Dim cRet As New Collection
    
    If VarType(Points) = (vbArray Or vbObject) Then
        For i = 0 To UBound(Points)
            sParam = sParam & sSng(Points(i).Lat) & "," & sSng(Points(i).Lng) & "|"
        Next
    Else
        For i = 1 To Points.Count
            sParam = sParam & sSng(Points(i).Lat) & "," & sSng(Points(i).Lng) & "|"
        Next
    End If
    
    sParam = Left$(sParam, Len(sParam) - 1)
    
    xmlDoc.async = False
    xmlDoc.Load "https://maps.googleapis.com/maps/api/elevation/xml?locations=" & sParam & "&key=" & m_ApiKey
    If xmlDoc.GetElementsByTagName("status").Length = 0 Then Exit Function
    If xmlDoc.GetElementsByTagName("status").Item(0).Text = "OK" Then
    
        For i = 0 To xmlDoc.GetElementsByTagName("elevation").Length - 1
            cRet.Add xmlDoc.GetElementsByTagName("elevation").Item(i).Text
        Next
        Set GetLocationsElevation = cRet
    End If

End Function
'Public Function GetLocationElevation(ByVal Lat As Single, ByVal Lng As Single)
'    Dim sJS As String
'
'    sJS = "var elevator = new google.maps.ElevationService();"
'    sJS = sJS & "var position = new google.maps.LatLng(" & sSng(Lat) & "," & sSng(Lng) & ");"
'    sJS = sJS & "elevator.getElevationForLocations({locations: [position]})"
'    sJS = sJS & "  .then(({ results }) => {"
'    sJS = sJS & "    if (results[0]) {"
'    sJS = sJS & "      vbH().RaiseMessageEvent('ElevationResults',results[0].elevation)" 'results[0].elevation);"
'    sJS = sJS & "    }"
'    sJS = sJS & " });"
'
'    Call WV.ExecuteScript(sJS)
'End Function

Public Function RemoveRoute(cRoute As ClsRoute)
    Call WV.ExecuteScript("DRender['" & ObjPtr(cRoute) & "'].setMap(null); DRender['" & ObjPtr(cRoute) & "'] =null;")
End Function

Public Function TraceRoute(cRoute As ClsRoute)
    Dim sFunciton As String, sJS As String
    Dim sUrl As String
    Dim sDis
    CreateDirectionsService
    CreateDirectionsRenderer cRoute

    sUrl = "sURL='https://www.google.com/maps/dir/';"
    sUrl = sUrl & "var legs = result.routes[0].legs;for (let i = 0; i < legs.length; i++) {sURL += encodeURIComponent(legs[i].start_address) + '/';if (i === legs.length - 1) {sURL += encodeURIComponent(legs[i].end_address) + '/';}}"
    sUrl = sUrl & "sURL += '@' + map.getCenter().lat().toFixed(6) + ',' + map.getCenter().lng().toFixed(6) + ',' + map.getZoom().toFixed(1) + 'z';"

    sFunciton = "function(result, status) {if (status == 'OK') {directionsRenderer.setDirections(result);}};"
    sJS = "var callback = " & sFunciton & vbCrLf
    sJS = sJS & "var request = eval(""(" + cRoute.ToString + ")"");" & vbCrLf
    sJS = sJS & "directionsService.route(request, callback);"

    Call WV.ExecuteScript(sJS)
    


'MsgBox WV.jsProp("Distance")
    
   ' cRoute.distance = WebBrowser1.Document.ParentWindow.distance
   ' cRoute.ShareUrl = WebBrowser1.Document.ParentWindow.sURL
   ' cRoute.Duration = WebBrowser1.Document.ParentWindow.Duration
    

End Function



Private Sub CreateDirectionsService()
    Dim sJS As String

    sJS = "var directionsService = new google.maps.DirectionsService;"
    Call WV.ExecuteScript(sJS)
End Sub

Private Sub CreateDirectionsRenderer(cRoute As ClsRoute)
    Dim sJS As String
    Dim sUrl As String
    
    sJS = "var directionsRenderer = new google.maps.DirectionsRenderer({map: map,draggable: " & sBool(cRoute.draggable)
    If cRoute.LineColor <> -1 Then sJS = sJS & ", polylineOptions: {strokeColor:'" & VBColorToRGB(cRoute.LineColor) & "', strokeOpacity: 0.5, strokeWeight: 5}"
    sJS = sJS & ", });"
    
    Call WV.ExecuteScript(sJS)
    
    sUrl = "sURL='https://www.google.com/maps/dir/';"
    sUrl = sUrl & "var legs = directionsRenderer.getDirections().routes[0].legs;for (let i = 0; i < legs.length; i++) {sURL += encodeURIComponent(legs[i].start_address) + '/';if (i === legs.length - 1) {sURL += encodeURIComponent(legs[i].end_address) + '/';}}"
    sUrl = sUrl & "sURL += '@' + map.getCenter().lat().toFixed(6) + ',' + map.getCenter().lng().toFixed(6) + ',' + map.getZoom().toFixed(1) + 'z';"
   
    
    sJS = "google.maps.event.addListener(directionsRenderer, 'directions_changed', function(){" & _
    "Distance = 0; Duration = 0;" & _
    "for (var i = 0; i < directionsRenderer.getDirections().routes[0].legs.length; i++) {" & _
    "  Distance += directionsRenderer.getDirections().routes[0].legs[i].distance.value;" & _
    "  Duration += directionsRenderer.getDirections().routes[0].legs[i].duration.value;" & _
    " console.log(directionsRenderer.getDirections().routes[0].legs[i].duration.value);" & _
    "};" & sUrl & "vbH().RaiseMessageEvent('directions_changed','" & ObjPtr(cRoute) & "'); })"
    

    Call WV.ExecuteScript(sJS)
    
'    sJS = "google.maps.event.addListener(directionsRenderer, 'directions_changed', function() {"
'    sJS = sJS & " vbH().RaiseMessageEvent('directions_changed','" & ObjPtr(cRoute) & "');"
'    sJS = sJS & "});"
'    Call WV.ExecuteScript(sJS)
    
    
    Call WV.ExecuteScript("DRender['" & ObjPtr(cRoute) & "'] = directionsRenderer;")

End Sub

Private Sub MarkerAddListener(ByVal Index As Long, ByVal EventName As String, ItemData As String)
    Dim sJS As String
    'sJS = "Markers[" & Index & "].addListener( '" & EventName & "', function(){vbH().RaiseMessageEvent('marker_" & EventName & "',Markers[" & Index & "].ItemData)})"
    sJS = "Markers[" & Index & "].addListener( '" & EventName & "', function(){vbH().RaiseMessageEvent('marker_" & EventName & "', '" & ItemData & "')})"
    Call WV.ExecuteScript(sJS)
End Sub

Private Sub MarkerRemoveListener(ByVal Index As Long, ByVal EventName As String)
    Dim sJS As String
    sJS = "google.maps.event.clearListeners(Markers[" & Index & "], '" & EventName & "');"
    Call WV.ExecuteScript(sJS)
End Sub

Public Function MarkerAdd(ByVal Lat As String, ByVal Lng As String, Optional ItemData As String) As Long
    Dim sJS As String
    Dim lCount As Long
    lCount = WV.jsProp("Markers.length")
    sJS = "marker = new google.maps.Marker({"
    sJS = sJS & "position: new google.maps.LatLng(" & sSng(Lat) & "," & sSng(Lng) & "),"
    sJS = sJS & "draggable:false,"
    sJS = sJS & "map: map,"
    sJS = sJS & "label:'',"
    sJS = sJS & "icon:'',"
    sJS = sJS & "title:'',"
    sJS = sJS & "animation: 0,"
    If IsMissing(ItemData) Then
        sJS = sJS & "ItemData: '',"
    Else
        sJS = sJS & "ItemData: '" & ItemData & "',"
    End If
    
    sJS = sJS & "});"
    sJS = sJS & "Markers.push(marker);"

    Call WV.ExecuteScript(sJS)

    MarkerAdd = lCount + 1
    
    Dim E As Variant
    For Each E In Split(MARKER_EVENTS, ",")
        MarkerAddListener lCount, E, ItemData
    Next
End Function

Public Function MarkerRemove(ByVal Index As Long) As Long
    Dim E As Variant

    For Each E In Split(MARKER_EVENTS, ",")
        MarkerRemoveListener Index, E
    Next

    Call WV.ExecuteScript("Markers[" & Index & "].setMap(null)")
    Call WV.ExecuteScript("Markers.splice(" & Index & ", 1)")
    DoEvents
    MarkerRemove = WV.jsProp("Markers.length")
End Function

Public Function MarkerIndexFromItemData(ByVal ItemData As String) As Long
    Dim i As Long
    MarkerIndexFromItemData = -1
    For i = 0 To MarkerCount - 1
        If MarkerData(i) = ItemData Then
            MarkerIndexFromItemData = i
            Exit Function
        End If
    Next
End Function

Public Function MarkerCount() As Long
    MarkerCount = WV.jsProp("Markers.length")
End Function

Public Property Let MarkerData(ByVal Index As Long, ByVal Value As Variant)
    Call WV.ExecuteScript("Markers[" & Index & "].ItemData = '" & Value & "'")
End Property

Public Property Get MarkerData(ByVal Index As Long) As Variant
    MarkerData = WV.jsProp("Markers[" & Index & "].ItemData")
End Property

Public Property Let MarkerAnimation(ByVal Index As Long, ByVal Value As eAnimation)
    Call WV.ExecuteScript("Markers[" & Index & "].animation = '" & Value & "'")
    Call WV.ExecuteScript("Markers[" & Index & "].setAnimation( '" & Value & "')")
End Property

Public Property Get MarkerAnimation(ByVal Index As Long) As eAnimation
    MarkerAnimation = WV.jsProp("Markers[" & Index & "].animation")
End Property

Public Property Let MarkerDraggable(ByVal Index As Long, ByVal Value As Boolean)
    Call WV.ExecuteScript("Markers[" & Index & "].setOptions({draggable: " & sBool(Value) & "})")
End Property

Public Property Get MarkerDraggable(ByVal Index As Long) As Boolean
    MarkerDraggable = WV.jsProp("Markers[" & Index & "].draggable")
End Property

Public Property Let MarkerLabel(ByVal Index As Long, ByVal Value As String)
    Call WV.ExecuteScript("Markers[" & Index & "].setOptions({label: {text:'" & Value & "'}})")
End Property

Public Property Get MarkerLabel(ByVal Index As Long) As String
    MarkerLabel = WV.jsProp("Markers[" & Index & "].getLabel().text")
End Property

'Public Property Let MarkerLabelColor(ByVal Index As Long, ByVal Value As OLE_COLOR)
'    Call WV.ExecuteScript("Markers[" & Index & "].setLabel({Color: 'blue'})")
'End Property
'
'Public Property Get MarkerLabelColor(ByVal Index As Long) As OLE_COLOR
'    MarkerLabelColor = WV.jsProp("Markers[" & Index & "].getLabel().color")
'End Property

Public Property Let MarkerIcon(ByVal Index As Long, ByVal Value As String)
    Call WV.ExecuteScript("Markers[" & Index & "].setOptions({icon:'" & Value & "'})")
End Property

Public Property Get MarkerIcon(ByVal Index As Long) As String
    MarkerIcon = WV.jsProp("Markers[" & Index & "].icon")
End Property

Public Property Let MarkerTitle(ByVal Index As Long, ByVal Value As String)
    Call WV.ExecuteScript("Markers[" & Index & "].setTitle('" & Value & "')")
End Property

Public Property Get MarkerTitle(ByVal Index As Long) As String
    MarkerTitle = WV.jsProp("Markers[" & Index & "].title")
End Property

Public Property Get MarkerLatitude(ByVal Index As Long) As String
    MarkerLatitude = WV.jsProp("Markers[" & Index & "].getPosition().lat()")
End Property

Public Property Get MarkerLongitude(Index) As String
    MarkerLongitude = WV.jsProp("Markers[" & Index & "].getPosition().lng()")
End Property

Public Sub MarkerSetPosition(Index, ByVal Lat As String, ByVal Lng As String)
    Call WV.ExecuteScript("Markers[" & Index & "].setPosition({ lat: " & sSng(Lat) & ", lng: " & sSng(Lng) & " })")
End Sub

Public Sub MarkerSetPositionByAddress(ByVal Index As Long, ByVal StrAddress As String)
    Dim sJS As String

    sJS = "var geocoder = new google.maps.Geocoder();"
    sJS = sJS & "geocoder.geocode({'address': '" & StrAddress & "'}, function(results, status) {"
    sJS = sJS & "if (status === 'OK') {Markers[" & Index & "].setPosition(results[0].geometry.location);} });"
    Call WV.ExecuteScript(sJS)
End Sub

Public Function MapSetCenterByAddress(ByVal StrAddress As String)
    Dim sJS As String

    sJS = "var geocoder = new google.maps.Geocoder();"
    sJS = sJS & "geocoder.geocode({'address': '" & StrAddress & "'}, function(results, status) {"
    sJS = sJS & "if (status === 'OK') {map.setCenter(results[0].geometry.location);} });"
    Call WV.ExecuteScript(sJS)
End Function



Public Sub LoadGeoJson(ByVal Url As String)
    Call WV.ExecuteScript("map.data.loadGeoJson('" & Url & "');")
End Sub

Public Sub RemoveGeoJson()
    Dim sJS As String
    sJS = sJS & "map.data.forEach(function(feature) {"
    sJS = sJS & "  map.data.remove(feature);"
    sJS = sJS & "});"
    Call WV.ExecuteScript(sJS)
End Sub

Public Sub LoadKmlLayer(ByVal KmlUrl As String)
    Dim sJS As String
    If Len(WV.jsProp("ctaLayer.getMap().toString()")) Then
        sJS = sJS & "ctaLayer.setUrl('" & KmlUrl & "');"
        sJS = sJS & "ctaLayer.setMap(map);"
    Else
        sJS = sJS & "var ctaLayer = new google.maps.KmlLayer({"
        sJS = sJS & "url: '" & KmlUrl & "',"
        sJS = sJS & "map: map,"
        sJS = sJS & "});"
    End If
    
    Call WV.ExecuteScript(sJS)
End Sub
 
Public Property Let TrafficLayer(ByVal NewValue As Boolean)
    Dim sJS As String
    If Len(WV.jsProp("TrafficLayer.toString()")) = 0 Then
        sJS = "const TrafficLayer = new google.maps.TrafficLayer();"
    End If
    
    If NewValue Then
        sJS = sJS & "TrafficLayer.setMap(map);"
    Else
        sJS = sJS & "TrafficLayer.setMap(null);"
    End If
    Call WV.ExecuteScript(sJS)
End Property

Public Property Get TrafficLayer() As Boolean
    TrafficLayer = Len(WV.jsProp("TrafficLayer.getMap().toString()"))
End Property

Public Property Let TransitLayer(ByVal NewValue As Boolean)
    Dim sJS As String
    If Len(WV.jsProp("TransitLayer.toString()")) = 0 Then
        sJS = "const TransitLayer = new google.maps.TransitLayer();"
    End If
    
    If NewValue Then
        sJS = sJS & "TransitLayer.setMap(map);"
    Else
        sJS = sJS & "TransitLayer.setMap(null);"
    End If
    Call WV.ExecuteScript(sJS)

End Property

Public Property Get TransitLayer() As Boolean
    TransitLayer = Len(WV.jsProp("TransitLayer.getMap().toString()"))
End Property


Public Property Let BicyclingLayer(ByVal NewValue As Boolean)
    Dim sJS As String
    If Len(WV.jsProp("BicyclingLayer .toString()")) = 0 Then
        sJS = "const BicyclingLayer  = new google.maps.BicyclingLayer ();"
    End If
    
    If NewValue Then
        sJS = sJS & "BicyclingLayer .setMap(map);"
    Else
        sJS = sJS & "BicyclingLayer .setMap(null);"
    End If
    Call WV.ExecuteScript(sJS)
End Property

Public Property Get BicyclingLayer() As Boolean
    BicyclingLayer = Len(WV.jsProp("BicyclingLayer .getMap().toString()"))
End Property

Public Sub CreateHeatMap(Points, Optional Opacity As Single = 1, Optional Gradient As Variant, Optional Radius As Long)
    Dim i As Long
    
    With New_c.StringBuilder
     
        If Len(WV.jsProp("heatmap.getMap().toString()")) Then
            .AddNL "heatmapData = ["
            If VarType(Points) = (vbArray Or vbObject) Then
                For i = 0 To UBound(Points)
                     .AddNL Points(i).GetGpoint & ","
                Next
            Else
                For i = 1 To Points.Count
                    .AddNL Points(i).GetGpoint & ","
                Next
            End If
            .AddNL "];"
        
            .AddNL "heatmap.setData(heatmapData);"
        Else
            .AddNL "var heatmap"
            .AddNL "var heatmapData = ["
            If VarType(Points) = (vbArray Or vbObject) Then
                For i = 0 To UBound(Points)
                     .AddNL Points(i).GetGpoint & ","
                Next
            Else
                For i = 1 To Points.Count
                    .AddNL Points(i).GetGpoint & ","
                Next
            End If
            .AddNL "];"
        
            .AddNL "heatmap = new google.maps.visualization.HeatmapLayer({data:heatmapData});"
            .AddNL "heatmap.setMap(map);"
            If Opacity < 1 Then .AddNL "heatmap.set('opacity'," & sSng(Opacity) & ");"
            
            If Not IsMissing(Gradient) Then
                Dim sGradient As String
                sGradient = "['rgba(0,0,0,0)',"
                For i = LBound(Gradient) To UBound(Gradient)
                    sGradient = sGradient & "'" & VBColorToRGBA(Gradient(i), 100) & "',"
                Next
                sGradient = sGradient & "]"
                .AddNL "heatmap.set('gradient'," & sGradient & ");"
            End If
            
            If Radius > 0 Then .AddNL "heatmap.set('radius'," & sSng(Radius) & ");"
        End If
        'Debug.Print .ToString
        Call WV.ExecuteScript(.ToString)
        
    End With
        
'    With New_c.StringBuilder
'        .AddNL "function changeGradient() {"
'        .AddNL "  const gradient = ["
'        .AddNL "      'rgba(0, 255, 255, 0)',"
'        .AddNL "      'rgba(0, 255, 255, 1)',"
'        .AddNL "      'rgba(0, 191, 255, 1)',"
'        .AddNL "      'rgba(0, 127, 255, 1)',"
'        .AddNL "      'rgba(0, 63, 255, 1)',"
'        .AddNL "     'rgba(0, 0, 255, 1)',"
'        .AddNL "      'rgba(0, 0, 223, 1)',"
'        .AddNL "      'rgba(0, 0, 191, 1)',"
'        .AddNL "      'rgba(0, 0, 159, 1)',"
'        .AddNL "      'rgba(0, 0, 127, 1)',"
'        .AddNL "      'rgba(63, 0, 91, 1)',"
'        .AddNL "      'rgba(127, 0, 63, 1)',"
'        .AddNL "     'rgba(191, 0, 31, 1)',"
'        .AddNL "      'rgba(255, 0, 0, 1)',"
'        .AddNL "    ];"
'        .AddNL "    heatmap.set('gradient', heatmap.get('gradient') ? null : gradient);}"
'        Call WV.ExecuteScript(.ToString)
'    End With

End Sub

Public Sub RemoveHeatMap()
    Call WV.ExecuteScript("heatmap.setMap(null);")
End Sub


Public Function InfoWindowAdd(ByVal Content As String, Optional ByVal maxWidth As Long)
    Dim sJS As String
    sJS = "var infowindow = new google.maps.InfoWindow({"
    sJS = sJS & "content: '" & Content & "',"
    sJS = sJS & "maxWidth: " & maxWidth & "});"
    sJS = sJS & "InfoWindows.push(infowindow);"
    Call WV.ExecuteScript(sJS)
    DoEvents
    InfoWindowAdd = WV.jsProp("InfoWindows.length")
End Function

Public Function InfoWindowCount() As Long
    InfoWindowCount = WV.jsProp("InfoWindows.length")
End Function

Public Sub InfoWindowSetContent(ByVal Index As Long, ByVal Content As String)
    Call WV.ExecuteScript("InfoWindows[" & Index & "].setContent('" & Content & "');")
End Sub

Public Function InfoWindowOpenInMap(ByVal Index As Long, ByVal Lat As String, ByVal Lng As String)
    Dim sJS As String
    sJS = sJS & "InfoWindows[" & Index & "].setPosition({lat:" & sSng(Lat) & ", lng:" & sSng(Lng) & "});"
    sJS = sJS & "InfoWindows[" & Index & "].open(map)"
    Call WV.ExecuteScript(sJS)
End Function

Public Function InfoWindowOpenInMarkers(ByVal Index As Long, ByVal MarkerIndex As Long)
    Dim sJS As String
    sJS = "InfoWindows[" & Index & "].open( map, Markers[" & MarkerIndex & "])"
    Call WV.ExecuteScript(sJS)
End Function


Public Function InfoWindowClose(ByVal Index As Long)
    Call WV.ExecuteScript("InfoWindows[" & Index & "].close()")
End Function

Public Function InfoWindowRemove(ByVal Index As Long) As Long
    Call WV.ExecuteScript("InfoWindows[" & Index & "].close()")
    Call WV.ExecuteScript("InfoWindows.splice(" & Index & ", 1)")
    DoEvents
    InfoWindowRemove = WV.jsProp("InfoWindows.length")
End Function

Public Sub MapRestriction(ByVal North As Single, ByVal South As Single, ByVal West As Single, ByVal East As Single)
    Dim sOptions As String
    Dim sBounds As String
    sBounds = "{north: " & sSng(North) & ", south: " & sSng(South) & ", west: " & sSng(West) & ", east: " & sSng(East) & "}"
    sOptions = "({restriction:{latLngBounds: " & sBounds & ", strictBounds: false}})"
    Call WV.ExecuteScript("map.setOptions" & sOptions)
End Sub

Public Property Let MapTilt(ByVal Value As Single)
    Call WV.ExecuteScript("map.setTilt(" & sSng(Value) & ")")
End Property

Public Property Get MapTilt() As Single
    If Not WV Is Nothing Then MapTilt = WV.jsProp("map.getTilt()")
End Property

Public Property Let MapHeading(ByVal Value As Single)
    Call WV.ExecuteScript("map.setHeading(" & sSng(Value) & ")")
End Property

Public Property Get MapHeading() As Single
    If Not WV Is Nothing Then MapHeading = WV.jsProp("map.getHeading()")
End Property

Public Property Get MapCenterLatitude() As Single
    If Not WV Is Nothing Then MapCenterLatitude = WV.jsProp("map.getCenter().lat()")
End Property

Public Property Let MapCenterLatitude(ByVal NewValue As Single)
    m_MapCenter.Lat = NewValue
    Call WV.ExecuteScript("map.setCenter({lat:" & sSng(m_MapCenter.Lat) & ", lng:" & sSng(m_MapCenter.Lng) & "})")
    UserControl.PropertyChanged "MapCenterLatitude"
End Property

Public Property Get MapCenterLongitude() As Single
    If Not WV Is Nothing Then MapCenterLongitude = WV.jsProp("map.getCenter().lng()")
End Property

Public Property Let MapCenterLongitude(ByVal NewValue As Single)
    m_MapCenter.Lng = NewValue
    Call WV.ExecuteScript("map.setCenter({lat:" & sSng(m_MapCenter.Lat) & ", lng:" & sSng(m_MapCenter.Lng) & "})")
    UserControl.PropertyChanged "MapCenterLongitude"
End Property

Public Function MapPanTo(ByVal Lat As String, ByVal Lng As String)
    m_MapCenter.Lat = Lat
    m_MapCenter.Lng = Lng
    Call WV.ExecuteScript("map.panTo({lat:" & sSng(m_MapCenter.Lat) & ", lng:" & sSng(m_MapCenter.Lng) & "})")
End Function

Public Function MapCenter(ByVal Lat As String, ByVal Lng As String)
    m_MapCenter.Lat = Lat
    m_MapCenter.Lng = Lng
    Call WV.ExecuteScript("map.setCenter({lat:" & sSng(m_MapCenter.Lat) & ", lng:" & sSng(m_MapCenter.Lng) & "})")
End Function

Public Property Get MapTypeId() As eMapType
    If WV Is Nothing Then Exit Property
    Select Case WV.jsProp("map.getMapTypeId()")
        Case "hybrid"
            MapTypeId = MT_HYBRID
        Case "roadmap"
            MapTypeId = MT_ROADMAP
        Case "satellite"
            MapTypeId = MT_SATELLITE
    End Select
End Property

Public Property Let MapTypeId(ByVal NewValue As eMapType)
    m_MapTypeId = NewValue
    If WV Is Nothing Then Exit Property
    If NewValue = MT_HYBRID Then
        Call WV.ExecuteScript("map.setMapTypeId('hybrid')")
    ElseIf NewValue = MT_ROADMAP Then
        Call WV.ExecuteScript("map.setMapTypeId('roadmap')")
    ElseIf NewValue = MT_SATELLITE Then
        Call WV.ExecuteScript("map.setMapTypeId('satellite')")
    End If
    UserControl.PropertyChanged "MapTypeId"
End Property

Public Property Get zoom() As Integer
    If Not WV Is Nothing Then zoom = WV.jsProp("map.getZoom()")
End Property

Public Property Let zoom(ByVal NewValue As Integer)
    m_Zoom = NewValue
    Call WV.ExecuteScript("map.setZoom(" & NewValue & ")")
    UserControl.PropertyChanged "Zoom"
End Property

Public Property Get ZoomControl() As Boolean
    ZoomControl = m_zoomControl
End Property

Public Property Let ZoomControl(ByVal NewValue As Boolean)
    m_zoomControl = NewValue
    Call WV.ExecuteScript("map.setOptions({zoomControl:" & sBool(NewValue) & "})")
    UserControl.PropertyChanged "zoomControl"
End Property

Public Property Get StreetViewControl() As Boolean
    StreetViewControl = m_streetViewControl
End Property

Public Property Let StreetViewControl(ByVal NewValue As Boolean)
    m_streetViewControl = NewValue
    Call WV.ExecuteScript("map.setOptions({streetViewControl:" & sBool(NewValue) & "})")
    UserControl.PropertyChanged "streetViewControl"
End Property

Public Property Get fullscreenControl() As Boolean
    fullscreenControl = m_fullscreenControl
End Property

Public Property Let fullscreenControl(ByVal NewValue As Boolean)
    m_fullscreenControl = NewValue
    Call WV.ExecuteScript("map.setOptions({fullscreenControl:" & sBool(NewValue) & "})")
    UserControl.PropertyChanged "fullscreenControl"
End Property

Public Property Get MapTypeControl() As Boolean
    MapTypeControl = m_mapTypeControl
End Property

Public Property Let MapTypeControl(ByVal NewValue As Boolean)
    m_mapTypeControl = NewValue
    Call WV.ExecuteScript("map.setOptions({mapTypeControl:" & sBool(NewValue) & "})")
    UserControl.PropertyChanged "mapTypeControl"
End Property

Public Property Get DisableDefaultUI() As Boolean
    DisableDefaultUI = m_DisableDefaultUI
End Property

Public Property Let DisableDefaultUI(ByVal NewValue As Boolean)
    m_DisableDefaultUI = NewValue
    Call WV.ExecuteScript("map.setOptions({disableDefaultUI:" & sBool(NewValue) & "})")
    UserControl.PropertyChanged "DisableDefaultUI"
End Property

Public Property Get ShadowOffsetX() As Long
    ShadowOffsetX = m_ShadowOffsetX
End Property

Public Property Let ShadowOffsetX(ByVal New_Value As Long)
    m_ShadowOffsetX = New_Value
    PropertyChanged "ShadowOffsetX"
    UpdateStyle
End Property

Public Property Get ShadowOffsetY() As Long
    ShadowOffsetY = m_ShadowOffsetY
End Property

Public Property Let ShadowOffsetY(ByVal New_Value As Long)
    m_ShadowOffsetY = New_Value
    PropertyChanged "ShadowOffsetY"
    UpdateStyle
End Property

Public Property Get ShadowColor() As OLE_COLOR
    ShadowColor = m_ShadowColor
End Property

Public Property Let ShadowColor(ByVal New_Value As OLE_COLOR)
    m_ShadowColor = New_Value
    PropertyChanged "ShadowColor"
    UpdateStyle
End Property

Public Property Get ShadowOpacity() As Long
    ShadowOpacity = m_ShadowOpacity
End Property

Public Property Let ShadowOpacity(ByVal New_Value As Long)
    m_ShadowOpacity = New_Value
    PropertyChanged "ShadowOpacity"
    UpdateStyle
End Property

Public Property Get ShadowSize() As Long
    ShadowSize = m_ShadowSize
End Property

Public Property Let ShadowSize(ByVal New_Value As Long)
    m_ShadowSize = New_Value
    PropertyChanged "ShadowSize"
    UpdateStyle
End Property

Public Property Get BorderRadius() As Long
    BorderRadius = m_BorderRadius
End Property

Public Property Let BorderRadius(ByVal New_Value As Long)
    m_BorderRadius = New_Value
    PropertyChanged "BorderRadius"
    UpdateStyle
End Property

Public Property Get BorderColor() As OLE_COLOR
    BorderColor = m_BorderColor
End Property

Public Property Let BorderColor(ByVal New_Value As OLE_COLOR)
    m_BorderColor = New_Value
    PropertyChanged "BorderColor"
    UpdateStyle
End Property

Public Property Get BorderWidth() As Long
    BorderWidth = m_BorderWidth
End Property

Public Property Let BorderWidth(ByVal New_Value As Long)
    m_BorderWidth = New_Value
    PropertyChanged "BorderWidth"
    UpdateStyle
End Property

Public Property Get ParentBackColor() As OLE_COLOR
   ParentBackColor = UserControl.BackColor
End Property

Public Property Let ParentBackColor(ByVal New_Color As OLE_COLOR)
    UserControl.BackColor = New_Color
    Picture1.BackColor = New_Color
    PropertyChanged "ParentBackColor"
    UpdateStyle
End Property

Public Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Value As Boolean)
    m_Enabled = New_Value
    If Ambient.UserMode Then
        UserControl.Enabled = m_Enabled
    End If
    
    PropertyChanged "Enabled"
End Property

Public Property Get ApiKey() As String
    ApiKey = m_ApiKey
End Property

Public Property Let ApiKey(ByVal New_Value As String)
    m_ApiKey = New_Value
    PropertyChanged "ApiKey"
End Property



Function VBColorToRGB(vbColor As Long) As String
    Dim red As Integer, green As Integer, blue As Integer
    If (vbColor And &H80000000) Then vbColor = GetSysColor(vbColor And &HFF&)
    red = vbColor And &HFF
    green = (vbColor \ &H100) And &HFF
    blue = (vbColor \ &H10000) And &HFF
    VBColorToRGB = "#" & Right("0" & Hex(red), 2) & Right("0" & Hex(green), 2) & Right("0" & Hex(blue), 2)
End Function

Public Function VBColorToRGBA(ByVal vbColor As Long, ByVal alpha As Long) As String
    Dim red As Integer, green As Integer, blue As Integer
    If (vbColor And &H80000000) Then vbColor = GetSysColor(vbColor And &HFF&)
    red = vbColor And &HFF
    green = (vbColor \ &H100) And &HFF
    blue = (vbColor \ &H10000) And &HFF
    VBColorToRGBA = "rgba(" & red & "," & green & "," & blue & "," & sSng(alpha / 100) & ")"
End Function

'Convert a single/double value in a string no matter the regional configuration for decimals
'Used on ReadProperties
Private Function FixDec(S$) As Double
    FixDec = Val(Replace(S$, ",", "."))
End Function

Private Function sBool(ByVal Value As Boolean) As String
    sBool = IIf(Value, "true", "false")
End Function

Public Function sSng(ByVal Value As Variant) As String
    sSng = Replace(Value, ",", ".")
End Function

Private Function GetWindowsDPI() As Double
    Dim hDC As Long, lPx  As Double
    Const LOGPIXELSX        As Long = 88

    hDC = GetDC(0)
    lPx = CDbl(GetDeviceCaps(hDC, LOGPIXELSX))
    ReleaseDC 0, hDC

    If (lPx = 0) Then
        GetWindowsDPI = 1#
    Else
        GetWindowsDPI = lPx / 96#
    End If
End Function


Private Sub UpdateStyle()
    
    WV.jsProp("document.body.style.backgroundColor") = VBColorToRGB(UserControl.BackColor)
    WV.jsProp("document.querySelector('#map_canvas').style.borderRadius") = m_BorderRadius & "px"
    WV.jsProp("document.querySelector('#map_canvas').style.border") = m_BorderWidth & "px solid " & VBColorToRGB(m_BorderColor)
    WV.jsProp("document.querySelector('#map_canvas').style.boxShadow") = m_ShadowOffsetX & "px " & m_ShadowOffsetY & "px " & m_ShadowSize & "px " & m_ShadowSize & "px " & VBColorToRGBA(m_ShadowColor, m_ShadowOpacity)
    

    UserControl_Resize
    
End Sub



Private Sub Timer1_Timer()
    WV.jsProp("document.querySelector('#map_canvas').style.width") = sSng(UserControl.ScaleWidth / DpiF - m_BorderWidth * 2 - m_ShadowSize * 4 - Abs(m_ShadowOffsetX)) & "px"
    WV.jsProp("document.querySelector('#map_canvas').style.height") = sSng(UserControl.ScaleHeight / DpiF - m_BorderWidth * 2 - m_ShadowSize * 4 - Abs(m_ShadowOffsetY)) & "px"
    WV.jsProp("document.querySelector('#map_canvas').style.left") = sSng(m_ShadowSize * 2 - (m_ShadowOffsetX)) & "px"
    WV.jsProp("document.querySelector('#map_canvas').style.top") = sSng(m_ShadowSize * 2 - (m_ShadowOffsetY)) & "px"

    Timer1.Interval = 0
End Sub



Private Sub Picture1_Resize()
    If Not WV Is Nothing Then
        WV.SyncSizeToHostWindow
        If Not Ambient.UserMode Then
            Timer1_Timer
        Else
            Timer1.Interval = 1
        End If
    End If
End Sub



Private Sub UserControl_EnterFocus()
  If Not Ambient.UserMode Then
    EnableWindow WV.HosthWnd, 1
    bEditMode = True
  End If
End Sub

Private Sub UserControl_ExitFocus()
  If Not Ambient.UserMode Then
    m_MapCenter.Lat = WV.jsProp("map.getCenter().lat()")
    m_MapCenter.Lng = WV.jsProp("map.getCenter().lng()")
    m_Zoom = WV.jsProp("map.getZoom()")
    Me.MapTypeId = Me.MapTypeId
    UserControl.PropertyChanged "MapCenterLatitude"
    UserControl.PropertyChanged "MapCenterLongitude"
    UserControl.PropertyChanged "Zoom"
    
    EnableWindow WV.HosthWnd, 0
    bEditMode = False
  End If
End Sub

Private Sub UserControl_Initialize()
    DpiF = GetWindowsDPI
End Sub

Private Sub UserControl_Resize()
    Picture1.Move 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight
    Picture1_Resize
End Sub

Private Sub UserControl_Show()
    Set WV = New_c.WebView2 'create the instance

    If WV.BindTo(Picture1.hwnd) = 0 Then MsgBox "couldn't initialize WebView-Binding": Exit Sub
 
    Dim sOptions As String, sStyle As String
    
    sOptions = "disableDefaultUI: " & sBool(m_DisableDefaultUI) & ", " & _
       "fullscreenControl: " & sBool(m_fullscreenControl) & ", " & _
       "streetViewControl: " & sBool(m_streetViewControl) & ", " & _
       "zoomControl: " & sBool(m_zoomControl) & ", " & _
       "mapTypeControl: " & sBool(m_mapTypeControl) & ", " & _
       "zoom: " & m_Zoom & ", " & _
       "center: {lat:" & sSng(m_MapCenter.Lat) & ",lng:" & sSng(m_MapCenter.Lng) & "}, " & _
       "mapTypeId: '" & IIf(m_MapTypeId = MT_HYBRID, "hybrid", IIf(m_MapTypeId = MT_ROADMAP, "roadmap", "satellite")) & "',"
    
    sStyle = "border-radius: " & m_BorderRadius & "px; " & _
            "border: " & m_BorderWidth & "px solid " & VBColorToRGB(m_BorderColor) & "; " & _
            "box-shadow: " & m_ShadowOffsetX & "px " & m_ShadowOffsetY & "px " & m_ShadowSize & "px " & m_ShadowSize & "px " & VBColorToRGBA(m_ShadowColor, m_ShadowOpacity) & "; " & _
            "width: " & sSng(UserControl.ScaleWidth / DpiF - m_BorderWidth * 2 - m_ShadowSize * 4 - Abs(m_ShadowOffsetX)) & "px; " & _
            "height: " & sSng(UserControl.ScaleHeight / DpiF - m_BorderWidth * 2 - m_ShadowSize * 4 - Abs(m_ShadowOffsetY)) & "px; " & _
            "left: " & sSng(m_ShadowSize * 2 - (m_ShadowOffsetX)) & "px; " & _
            "top: " & sSng(m_ShadowSize * 2 - (m_ShadowOffsetY)) & "px"

      With New_c.StringBuilder
        .AddNL "<html>"
        .AddNL "  <head>"
        .AddNL "    <style type='text/css'> html {height: 100%} body{height:100%;margin:0;padding:0;overflow-y:hidden;overflow-x:hidden;}</style>"
        .AddNL "    <script async src=""http://maps.googleapis.com/maps/api/js?key=" & m_ApiKey & "&libraries=visualization&callback=initMap""></script>"
        .AddNL "    <script type='text/javascript'>"
        .AddNL "        var map, sURL, Markers=[], InfoWindows=[], DRender={}, Distance, Duration, Retrive, hashPlaces ={}, elevation;"
        .AddNL "        function initMap() {"
        .AddNL "          map = new google.maps.Map(document.getElementById('map_canvas'), {" & sOptions & "});"
        .AddNL "          vbH().RaiseMessageEvent('MapInitialize','');}"
        .AddNL "    </script>"
        .AddNL "  </head>"
        .AddNL "  <body style='background-color: " & VBColorToRGB(UserControl.BackColor) & "'>"
        '.AddNL "    <div id='map_canvas' style='width:99%; height:99%'></div></div>"
        .AddNL "    <div id='map_canvas' style='" & sStyle & "'></div></div>"
        .AddNL "  </body>"
        .AddNL "</html>"

         'WV.NavigateToString .ToString
         Dim FF As Integer
         Dim sTempPath As String
         
         sTempPath = Environ("temp") & "\mapa.html"
         FF = FreeFile
    
         If Len(Dir(sTempPath)) Then Kill sTempPath
         Open sTempPath For Binary As #FF
            Put #FF, , .ToString
         Close #FF
         WV.Navigate sTempPath
         Debug.Print .ToString
      End With
    

      '  WV.Navigate "http://leandroascierto.com/vb/mapa.html"
      On Error Resume Next
      If Not Ambient.UserMode Then
        EnableWindow WV.HosthWnd, 0
      End If
      '
        
      'm_Chrome_WidgetWin_0 = FindWindowEx(UserControl.hwnd, 0, "Chrome_WidgetWin_0", vbNullString)

End Sub

Private Sub UserControl_InitProperties()
    m_BorderWidth = 1
    m_ShadowOpacity = 50
    m_BorderColor = vb3DLight
    UserControl.BackColor = Ambient.BackColor
    m_mapTypeControl = True
     m_fullscreenControl = True
    m_streetViewControl = True
    m_zoomControl = True
    m_Enabled = True
    m_ApiKey = DEFAULT_API_KEY
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        m_ApiKey = .ReadProperty("ApiKey", DEFAULT_API_KEY)
        m_ShadowSize = .ReadProperty("ShadowSize", 0)
        m_ShadowColor = .ReadProperty("ShadowColor", vbBlack)
        m_ShadowOffsetX = .ReadProperty("ShadowOffsetX", 0)
        m_ShadowOffsetY = .ReadProperty("ShadowOffsetY", 0)
        m_ShadowOpacity = .ReadProperty("ShadowOpacity", 50)
    
        m_DisableDefaultUI = .ReadProperty("DisableDefaultUI", False)
        m_mapTypeControl = .ReadProperty("mapTypeControl", True)
        m_fullscreenControl = .ReadProperty("fullscreenControl", True)
        m_streetViewControl = .ReadProperty("streetViewControl", True)
        m_zoomControl = .ReadProperty("zoomControl", True)
        m_BorderWidth = .ReadProperty("BorderWidth", 1)
        m_BorderRadius = .ReadProperty("BorderRadius", 0)
        m_BorderColor = .ReadProperty("BorderColor", vb3DLight)
        UserControl.BackColor = .ReadProperty("ParentBackColor", Ambient.BackColor)
        m_MapTypeId = .ReadProperty("MapTypeId", MT_HYBRID)
        m_MapCenter.Lat = FixDec(.ReadProperty("MapCenterLatitude", 0))
        m_MapCenter.Lng = FixDec(.ReadProperty("MapCenterLongitude", 0))
        m_Zoom = .ReadProperty("Zoom", 0)
        Picture1.BackColor = UserControl.BackColor
        m_Enabled = .ReadProperty("Enabled", True)
    End With
    
    Me.Enabled = m_Enabled

    'WebBrowser1.Navigate App.Path & "\mapa.html"
    'WebBrowser1.Silent = True
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "ApiKey", m_ApiKey, DEFAULT_API_KEY
        .WriteProperty "ShadowSize", m_ShadowSize, 0
        .WriteProperty "ShadowColor", m_ShadowColor, vbBlack
        .WriteProperty "ShadowOffsetX", m_ShadowOffsetX, 0
        .WriteProperty "ShadowOffsetY", m_ShadowOffsetY, 0
        .WriteProperty "ShadowOpacity", m_ShadowOpacity, 50
        .WriteProperty "DisableDefaultUI", m_DisableDefaultUI, False
        .WriteProperty "mapTypeControl", m_mapTypeControl, True
        .WriteProperty "fullscreenControl", m_fullscreenControl, True
        .WriteProperty "streetViewControl", m_streetViewControl, True
        .WriteProperty "zoomControl", m_zoomControl, True
        .WriteProperty "BorderWidth", m_BorderWidth, 1
        .WriteProperty "BorderRadius", m_BorderRadius, 0
        .WriteProperty "BorderColor", m_BorderColor, vb3DLight
        .WriteProperty "MapTypeId", m_MapTypeId, MT_HYBRID
        .WriteProperty "MapCenterLatitude", m_MapCenter.Lat, 0
        .WriteProperty "MapCenterLongitude", m_MapCenter.Lng, 0
        .WriteProperty "Zoom", m_Zoom, 0
        .WriteProperty "ParentBackColor", UserControl.BackColor, Ambient.BackColor
        .WriteProperty "Enabled", m_Enabled, True
    End With
End Sub


Public Sub OpenDevToolsWindow()
    WV.OpenDevToolsWindow
End Sub

Public Sub FullScreenChange(ByVal InFullscreen As Boolean)
    Dim Rec As RECT
    Const HWND_TOPMOST As Long = -1
    
    If InFullscreen Then
        SetParent Picture1.hwnd, GetDesktopWindow
        GetWindowRect GetDesktopWindow, Rec
        SetWindowPos Picture1.hwnd, HWND_TOPMOST, 0, 0, Rec.Right, Rec.Bottom, 0
    Else
        SetParent Picture1.hwnd, UserControl.hwnd
        GetWindowRect UserControl.hwnd, Rec
        SetWindowPos Picture1.hwnd, 0, 0, 0, Rec.Right - Rec.Left, Rec.Bottom - Rec.Top, 0
    End If
End Sub

Public Sub MapAddListener(ByVal EventName As String)
    Dim sJS As String
    sJS = "google.maps.event.addListener(map, '" & EventName & "', function(){vbH().RaiseMessageEvent('" & EventName & "','')});"
    Call WV.ExecuteScript(sJS)
End Sub



Private Sub WV_JSMessage(ByVal sMsg As String, ByVal sMsgContent As String, oJSONContent As cCollection)

    Select Case sMsg
    Case "tilesloaded"
        WV.jsProp("document.querySelector('#map_canvas > div > div > div:nth-child(17) > div').style.display") = "none"
        WV.jsProp("document.querySelector('#map_canvas > div > div > div:nth-child(15) > div').style.display") = "none"
    
    Case "MapInitialize"
'        Dim sOptions As String
'        sOptions = "({disableDefaultUI: " & sBool(m_DisableDefaultUI) & ", " & _
'           "fullscreenControl: " & sBool(m_fullscreenControl) & ", " & _
'           "streetViewControl: " & sBool(m_streetViewControl) & ", " & _
'           "zoomControl: " & sBool(m_zoomControl) & ", " & _
'           "mapTypeControl: " & sBool(m_mapTypeControl) & "})"
        
       ' Call WV.ExecuteScript("map.setOptions(" & sOptions & ")")
        'Call WV.ExecuteScript("document.querySelector('#map_canvas > div > div > div:nth-child(17) > div').style.display = 'none';")


'        Me.MapCenter m_MapCenter.Lat, m_MapCenter.Lng
'        Me.zoom = m_Zoom
        'Me.MapTypeId = m_MapTypeId

        'UpdateStyle
        'Timer1_Timer
        
        Dim sJS As String
        sJS = "function fullscreenchanged(event) {"
        sJS = sJS & "if (document.fullscreenElement) {"
        sJS = sJS & "vbH().RaiseMessageEvent('fullscreenchanged','true')"
        sJS = sJS & "} else {"
        sJS = sJS & "vbH().RaiseMessageEvent('fullscreenchanged','false')}}"
        sJS = sJS & "document.addEventListener('fullscreenchange', fullscreenchanged)"
        Call WV.ExecuteScript(sJS)
        'UpdateStyle
        Dim E As Variant
        sJS = ""
        For Each E In Split(MAP_EVENTS, ",")
            sJS = sJS & "google.maps.event.addListener(map, '" & E & "', function(event) {"
            Select Case E
            
                Case "click", "dblclick", "rightclick", "mousemove"
                    sJS = sJS & "    vbH().RaiseMessageEvent('" & E & "',event.latLng.toString())"
                Case Else
                    sJS = sJS & "    vbH().RaiseMessageEvent('" & E & "','')"
            End Select
            
            sJS = sJS & "});"
        Next
        Call WV.ExecuteScript(sJS)
        
        RaiseEvent LoadComplete
    Case "directions_changed"
        Dim oRoute As ClsRoute
        Dim tmpObj As ClsRoute
        CopyMemory tmpObj, CLng(sMsgContent), 4
        Set oRoute = tmpObj
        CopyMemory tmpObj, 0&, 4
            
        oRoute.distance = WV.jsProp("Distance")
        oRoute.ShareUrl = WV.jsProp("sURL")
        oRoute.Duration = WV.jsProp("Duration")
        
        oRoute.Origin = WV.jsProp("DRender['" & sMsgContent & "'].getDirections().routes[0].legs[0].start_address")
        Dim lCount As Long
        lCount = WV.jsProp("DRender['" & sMsgContent & "'].getDirections().routes[0].legs.length")
        oRoute.Destination = WV.jsProp("DRender['" & sMsgContent & "'].getDirections().routes[0].legs[" & lCount - 1 & "].end_address")
        
        RaiseEvent DirectionsChanged(oRoute)
        
    Case "ElevationResults"
        MsgBox sMsgContent
        
    Case "fullscreenchanged"
        FullScreenChange sMsgContent
        
    Case "GeolocationsResult"
        'Me.MarkerAdd Split(sMsgContent, ",")(0), Split(sMsgContent, ",")(1)
        RaiseEvent GeolocationResult(Split(sMsgContent, ",")(0), Split(sMsgContent, ",")(1))
    Case "center_changed"
    
    Case "click"
        sMsgContent = Mid$(sMsgContent, 2, Len(sMsgContent) - 2)
        RaiseEvent MapClick(Split(sMsgContent, ",")(0), Split(sMsgContent, ",")(1))
    Case "mousemove"
        sMsgContent = Mid$(sMsgContent, 2, Len(sMsgContent) - 2)
        RaiseEvent MapMouseMove(Split(sMsgContent, ",")(0), Split(sMsgContent, ",")(1))
    Case Else
        'Debug.Print sMsg, Left$(sMsg, 6)  ', WV.jsProp("map.getMapTypeId()")
        If Left$(sMsg, 6) = "marker" Then

            RaiseEvent MarkerEvents(Mid$(sMsg, 8), sMsgContent)
        ElseIf Left$(sMsg, 9) = "Selection" Then
          ' Debug.Print oJSONContent.Item("southwest")
          Dim sParams() As String
          sMsgContent = Replace$(sMsgContent, "(", "")
          sMsgContent = Replace$(sMsgContent, ")", "")
          sParams = Split(sMsgContent, ",")
            'Debug.Print sMsg, sMsgContent ', WV.jsProp("map.getMapTypeId()")
            RaiseEvent SelectionEvents(sMsg, sParams(2), sParams(0), sParams(3), sParams(1))
        End If
  End Select
End Sub

'Private Sub Command10_Click()
'
'    ' Ejemplo de uso
'    Dim origin_lat As Double ' Latitud del punto de origen
'    Dim origin_lon As Double ' Longitud del punto de origen
'    Dim dest_lat As Double ' Latitud del punto de destino
'    Dim dest_lon As Double ' Longitud del punto de destino
'    Dim distance As Double ' Distancia calculada
'
'    origin_lat = -33.103
'    origin_lon = -60.55
'    dest_lat = origin_lat + 0.2
'    dest_lon = origin_lon
'
'    distance = HaversineDistance(origin_lat, origin_lon, dest_lat, dest_lon)
'    MsgBox "Distancia: " & distance & " km"
'
'End Sub
'
'
'Function HaversineDistance(ByVal lat1 As Double, ByVal lon1 As Double, ByVal lat2 As Double, ByVal lon2 As Double) As Double
'    Const EarthRadius As Double = 6371 ' Radio de la Tierra en kilmetros
'    Const PI = 3.14159
'    ' Convertir las coordenadas de grados a radianes
'    Dim lat1_rad As Double
'    Dim lon1_rad As Double
'    Dim lat2_rad As Double
'    Dim lon2_rad As Double
'    lat1_rad = lat1 * (PI / 180)
'    lon1_rad = lon1 * (PI / 180)
'    lat2_rad = lat2 * (PI / 180)
'    lon2_rad = lon2 * (PI / 180)
'
'    ' Calcular las diferencias de latitud y longitud
'    Dim delta_lat As Double
'    Dim delta_lon As Double
'    delta_lat = lat2_rad - lat1_rad
'    delta_lon = lon2_rad - lon1_rad
'
'    ' Calcular la distancia utilizando la frmula de Haversine
'    Dim a As Double
'    Dim c As Double
'    a = Sin(delta_lat / 2) ^ 2 + Cos(lat1_rad) * Cos(lat2_rad) * Sin(delta_lon / 2) ^ 2
'    c = 2 * Atn(Sqr(a / (1 - a)))
'    HaversineDistance = EarthRadius * c
'End Function
